/**
 * Copyright (c) 2009-2011 Zauber S.A. <http://www.zaubersoftware.com/>
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package ar.com.zauber.commons.ws.connection.cxf;

import ar.com.zauber.commons.ws.connection.Configuration;

import org.apache.cxf.endpoint.Client;
import org.apache.cxf.frontend.ClientProxy;

/**
 * Abstract implementation of a configuration based on configuring the port
 * using its {@link Client}.
 * 
 * Implementor need to configure such client instead of the port itself
 * 
 * @author flbulgarelli
 */
public abstract class AbstractClientConfiguration implements Configuration<Object> {

   public final void configure(Object port) {
      configureClient(ClientProxy.getClient(port));
   }

   /**
    * Configures the port's {@link Client}
    * 
    * @param client
    *           the {@link Client} to configure
    */
   protected abstract void configureClient(Client client);
}
